"""A generate file containing all source files used to produce `cargo-bazel`"""

# Each source file is tracked as a target so the `cargo_bootstrap_repository`
# rule will know to automatically rebuild if any of the sources changed.
CARGO_BAZEL_SRCS = [
    "@rules_rust//crate_universe:src/cli.rs",
    "@rules_rust//crate_universe:src/cli/generate.rs",
    "@rules_rust//crate_universe:src/cli/query.rs",
    "@rules_rust//crate_universe:src/cli/splice.rs",
    "@rules_rust//crate_universe:src/cli/vendor.rs",
    "@rules_rust//crate_universe:src/config.rs",
    "@rules_rust//crate_universe:src/context.rs",
    "@rules_rust//crate_universe:src/context/crate_context.rs",
    "@rules_rust//crate_universe:src/context/platforms.rs",
    "@rules_rust//crate_universe:src/lib.rs",
    "@rules_rust//crate_universe:src/lockfile.rs",
    "@rules_rust//crate_universe:src/main.rs",
    "@rules_rust//crate_universe:src/metadata.rs",
    "@rules_rust//crate_universe:src/metadata/dependency.rs",
    "@rules_rust//crate_universe:src/metadata/metadata_annotation.rs",
    "@rules_rust//crate_universe:src/rendering.rs",
    "@rules_rust//crate_universe:src/rendering/template_engine.rs",
    "@rules_rust//crate_universe:src/rendering/templates/crate_build_file.j2",
    "@rules_rust//crate_universe:src/rendering/templates/module_build_file.j2",
    "@rules_rust//crate_universe:src/rendering/templates/module_bzl.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/aliases.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/binary.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/build_script.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/common_attrs.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/deps.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/library.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/crate/proc_macro.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/header.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/module/aliases_map.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/module/deps_map.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/module/repo_git.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/module/repo_http.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/starlark/glob.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/starlark/selectable_dict.j2",
    "@rules_rust//crate_universe:src/rendering/templates/partials/starlark/selectable_list.j2",
    "@rules_rust//crate_universe:src/rendering/templates/vendor_module.j2",
    "@rules_rust//crate_universe:src/splicing.rs",
    "@rules_rust//crate_universe:src/splicing/cargo_config.rs",
    "@rules_rust//crate_universe:src/splicing/splicer.rs",
    "@rules_rust//crate_universe:src/test.rs",
    "@rules_rust//crate_universe:src/utils.rs",
    "@rules_rust//crate_universe:src/utils/starlark.rs",
    "@rules_rust//crate_universe:src/utils/starlark/glob.rs",
    "@rules_rust//crate_universe:src/utils/starlark/label.rs",
    "@rules_rust//crate_universe:src/utils/starlark/select.rs",
]
